import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = "f698438c140b"
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "cve",
        sa.Column("name", sa.String(length=32), nullable=False),
        sa.Column("description", sa.Text(), nullable=False),
        sa.Column("scope", sa.String(length=64), nullable=False),
        sa.Column("debianbug", sa.Integer(), nullable=True),
        sa.PrimaryKeyConstraint("name"),
    )
    op.create_table(
        "packages", sa.Column("name", sa.String(length=64), nullable=False), sa.PrimaryKeyConstraint("name")
    )
    op.create_table(
        "package_cve",
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("package_name", sa.String(), nullable=False),
        sa.Column("cve_name", sa.String(), nullable=False),
        sa.Column("sid_status", sa.String(length=32), nullable=False),
        sa.Column("sid_urgency", sa.String(length=64), nullable=False),
        sa.Column("sid_fixed_version", sa.String(length=64), nullable=False),
        sa.Column("bullseye_status", sa.String(length=32), nullable=False),
        sa.Column("bullseye_urgency", sa.String(length=64), nullable=False),
        sa.Column("bullseye_fixed_version", sa.String(length=64), nullable=False),
        sa.Column("buster_status", sa.String(length=32), nullable=False),
        sa.Column("buster_urgency", sa.String(length=64), nullable=False),
        sa.Column("buster_fixed_version", sa.String(length=64), nullable=False),
        sa.Column("stretch_status", sa.String(length=32), nullable=False),
        sa.Column("stretch_urgency", sa.String(length=64), nullable=False),
        sa.Column("stretch_fixed_version", sa.String(length=64), nullable=False),
        sa.ForeignKeyConstraint(["cve_name"], ["cve.name"], ondelete="cascade"),
        sa.ForeignKeyConstraint(["package_name"], ["packages.name"], ondelete="cascade"),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint("package_name", "cve_name", name="_package_cve_unique"),
    )
    op.create_table(
        "subscriptions",
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("cve_name", sa.String(), nullable=False),
        sa.Column("chat_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(["cve_name"], ["cve.name"], ondelete="cascade"),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint("cve_name", "chat_id", name="_cve_chat_constraint"),
    )
    op.create_table(
        "notifications",
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("subscription_id", sa.Integer(), nullable=True),
        sa.Column("package_name", sa.String(), nullable=True),
        sa.Column("information", sa.Text(), nullable=False),
        sa.ForeignKeyConstraint(["package_name"], ["packages.name"], ondelete="cascade"),
        sa.ForeignKeyConstraint(["subscription_id"], ["subscriptions.id"], ondelete="cascade"),
        sa.PrimaryKeyConstraint("id"),
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("notifications")
    op.drop_table("subscriptions")
    op.drop_table("package_cve")
    op.drop_table("packages")
    op.drop_table("cve")
    # ### end Alembic commands ###
